/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package monogram.plugin;

import java.io.File;
import java.io.IOException;
import monogram.restorer.TxtRestorer;

/**
 * @author University of Waikato - Te Whare Wānanga o Waikato
 * @version 1.0
 * @since   2014-11-20 
 */
public class PluginTXT implements Plugin {

    private File tmpdir;

    public PluginTXT(File tmpdir) {
        this.tmpdir = tmpdir;
    }

    public File run(PluginConfiguration configuration) throws IllegalArgumentException, IOException {
        if (configuration.getCharsetEncoding() == null) {
           
            throw new IllegalArgumentException();
        }
        final File outputFile = File.createTempFile("mi-tmp-", configuration.getFileType(), tmpdir);
        final TxtRestorer restorer = new TxtRestorer();
        restorer.restore(configuration.getFile(), configuration.getCharsetEncoding(), outputFile, configuration.getPreserveExistingMacrons());
        return outputFile;
    }
}
