/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package monogram.model;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.HashSet;
import java.util.Set;
import util.Pool;


/**
 *
 * @author tl113
 */
public class ListModel {
      
        private Set<String> specialConditionsList; 
        private final String CHARSET_ENCODING = "utf-8";
        private final String DELIMITER = "\t";
    
        private Pool<String> pool;
        private final String path;
    
    public ListModel(String path, Pool<String> pool){
        this.path = path;
        this.pool = pool;
        specialConditionsList = new HashSet();
        init();
        
    }
    
    private void init() {
         BufferedReader reader = null;
        try {
            final String filepath = path;
            reader = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(filepath), CHARSET_ENCODING));
            String line;
            while ((line = reader.readLine()) != null) {
               // final String elements = line.split(DELIMITER);
                specialConditionsList.add(line);
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            close(reader);
        }
        
    }
    
     private void close(Reader reader) {
        if (reader != null) {
            try {
                reader.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
     
     public Set<String> getMonogramProbabilities() {
        return specialConditionsList;
    }
   
     public boolean contains(String s){
         
         if(specialConditionsList.contains(s)){
             
             return true; 
         }
         
         return false;
     }
    
    
}
